﻿using Syncfusion.Drawing;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace ChartToPdfExample
{
    public partial class MainPage : ContentPage
    {
        PdfDocument document = new PdfDocument();
        string fileName;
        public MainPage()
        {
            InitializeComponent();
            fileName = "Sample";
        }
        private void ButtonAddGrid_Clicked(object sender, EventArgs e)
        {
            if (document == null) document = new PdfDocument();

            // adding text to the PDF
            PdfPage page = document.Pages.Add();

            PdfStandardFont font = new PdfStandardFont(PdfFontFamily.Helvetica, 15);

            page.Graphics.DrawString("Grid table is shown below", font, PdfBrushes.Black, new PointF(20, 20));

            //Create a PdfGrid.

            PdfGrid pdfGrid = new PdfGrid();

            //Add values to list

            List<object> data = new List<object>();

            Object row1 = new { ID = "E01", Name = "Clay" };

            Object row2 = new { ID = "E02", Name = "Thomas" };

            data.Add(row1);

            data.Add(row2);

            //Add list to IEnumerable

            IEnumerable<object> dataTable = data;

            //Assign data source.

            pdfGrid.DataSource = dataTable;

            //Draw grid to the page of PDF document.

            pdfGrid.Draw(page, new Syncfusion.Drawing.PointF(20, 40));

        }
        private void Button_Clicked(object sender, EventArgs e)
        {
            if (document == null) document = new PdfDocument();
            //chart.WidthRequest = document.PageSettings.Width;
            //chart.HeightRequest = document.PageSettings.Height;
            PdfPage page = document.Pages.Add();
            var stream = chart.GetStream();
            PdfGraphics graphics = page.Graphics;
            graphics.DrawImage(PdfImage.FromStream(stream), 0, 0, page.GetClientSize().Width, page.GetClientSize().Height / 4);
        }
        private async void ButtonSave_Clicked(object sender, EventArgs e)
        {
            if (document == null) document = new PdfDocument();
            MemoryStream stream = new MemoryStream();
            document.Save(stream);
            document.Close();
            stream.Position = 0;
            await DependencyService.Get<ISave>().Save(fileName.Trim() + ".pdf", "application/pdf", stream);
            await DisplayAlert("Information", "The report is successfully saved to \"MyFiles/Chart/" + fileName.Trim() + ".pdf\"", "OK");
            await DependencyService.Get<ISave>().View();
            document = null;
        }
        private void ButtonVisibility_Clicked(object sender, EventArgs e)
        {
            chart.IsVisible = true;
        }
    }   
}
